Index: LMDZ5/trunk/libf/phylmd/cosp/cosp_radar.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/cosp_radar.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/cosp_radar.F90	(revision 2428)
@@ -26,4 +26,5 @@
   USE MOD_COSP_CONSTANTS
   USE MOD_COSP_TYPES
+  USE MOD_COSP_UTILS
   use radar_simulator_types
   use array_lib
@@ -31,12 +32,13 @@
   use format_input
   IMPLICIT NONE
-  
+
   INTERFACE
-    subroutine radar_simulator(freq,k2,do_ray,use_gas_abs,use_mie_table,mt, &
-        nhclass,hp,nprof,ngate,nsizes,D,hgt_matrix,hm_matrix,re_matrix,p_matrix,t_matrix, &
-        rh_matrix,Ze_non,Ze_ray,h_atten_to_vol,g_atten_to_vol,dBZe, &
+    subroutine radar_simulator(hp,nprof,ngate,undef, &
+        hgt_matrix,hm_matrix,re_matrix,Np_matrix, &
+        p_matrix,t_matrix,rh_matrix, &
+        Ze_non,Ze_ray,g_to_vol,a_to_vol,dBZe, &
         g_to_vol_in,g_to_vol_out)
-  
-        use m_mrgrnk 
+
+        use m_mrgrnk
         use array_lib
         use math_lib
@@ -44,20 +46,22 @@
         use radar_simulator_types
         implicit none
+
         ! ----- INPUTS -----  
-        type(mie), intent(in) :: mt
         type(class_param) :: hp
-        real*8, intent(in) :: freq,k2
-        integer, intent(in) ::  do_ray,use_gas_abs,use_mie_table, &
-            nhclass,nprof,ngate,nsizes
-        real*8, dimension(nsizes), intent(in) :: D
+
+        integer, intent(in) :: nprof,ngate
+
+        real undef
         real*8, dimension(nprof,ngate), intent(in) :: hgt_matrix, p_matrix, &
             t_matrix,rh_matrix
-        real*8, dimension(nhclass,nprof,ngate), intent(in) :: hm_matrix
-        real*8, dimension(nhclass,nprof,ngate), intent(inout) :: re_matrix
+        real*8, dimension(hp%nhclass,nprof,ngate), intent(in) :: hm_matrix
+        real*8, dimension(hp%nhclass,nprof,ngate), intent(inout) :: re_matrix
+        real*8, dimension(hp%nhclass,nprof,ngate), intent(inout) :: Np_matrix
+
         ! ----- OUTPUTS -----
         real*8, dimension(nprof,ngate), intent(out) :: Ze_non,Ze_ray, &
-            g_atten_to_vol,dBZe,h_atten_to_vol    
+            g_to_vol,dBZe,a_to_vol
         ! ----- OPTIONAL -----
-        real*8, optional, dimension(ngate,nprof) :: &
+        real*8, optional, dimension(nprof,ngate) :: &
             g_to_vol_in,g_to_vol_out
      end subroutine radar_simulator
@@ -73,5 +77,5 @@
 
   ! Arguments
-  type(cosp_gridbox),intent(in) :: gbx  ! Gridbox info
+  type(cosp_gridbox),intent(inout) :: gbx  ! Gridbox info
   type(cosp_subgrid),intent(in) :: sgx  ! Subgrid info
   type(cosp_sghydro),intent(in) :: sghydro  ! Subgrid info for hydrometeors
@@ -80,48 +84,38 @@
   ! Local variables 
   integer :: & 
-  nsizes			! num of discrete drop sizes
+  nsizes            ! num of discrete drop sizes
 
-  real*8 :: &
-  freq, &			! radar frequency (GHz)
-  k2 				! |K|^2, -1=use frequency dependent default
-  
   real*8, dimension(:,:), allocatable :: &
   g_to_vol ! integrated atten due to gases, r>v (dB)
-  
+
   real*8, dimension(:,:), allocatable :: &
-  Ze_non, &			! radar reflectivity withOUT attenuation (dBZ)
-  Ze_ray, &			! Rayleigh reflectivity (dBZ)
-  h_atten_to_vol, &		! attenuation by hydromets, radar to vol (dB)
-  g_atten_to_vol, &		! gaseous atteunation, radar to vol (dB)
-  dBZe, &			! effective radar reflectivity factor (dBZ)
-  hgt_matrix, &			! height of hydrometeors (km)
+  Ze_non, &         ! radar reflectivity withOUT attenuation (dBZ)
+  Ze_ray, &         ! Rayleigh reflectivity (dBZ)
+  h_atten_to_vol, &     ! attenuation by hydromets, radar to vol (dB)
+  g_atten_to_vol, &     ! gaseous atteunation, radar to vol (dB)
+  dBZe, &           ! effective radar reflectivity factor (dBZ)
+  hgt_matrix, &         ! height of hydrometeors (km)
   t_matrix, &                   !temperature (k)
   p_matrix, &                   !pressure (hPa)
   rh_matrix                     !relative humidity (%)
-  
+
   real*8, dimension(:,:,:), allocatable :: &
-  hm_matrix, &			! hydrometeor mixing ratio (g kg^-1)
-  re_matrix
+  hm_matrix, &          ! hydrometeor mixing ratio (g kg^-1)
+  re_matrix, &          ! effective radius (microns).   Optional. 0 ==> use Np_matrix or defaults
+  Np_matrix         ! total number concentration (kg^-1).   Optional 0==> use defaults 
 
   integer, parameter :: one = 1
-  logical :: hgt_reversed
-  integer :: pr,i,j,k,unt
+  ! logical :: hgt_reversed
+  logical :: hgt_descending
+  integer :: pr,i,j,k,unt,ngate
 
 ! ----- main program settings ------
-
-  freq = gbx%radar_freq
-  k2 = gbx%k2
- 
-  !
-  ! note:  intitialization section that was here has been relocated to SUBROUTINE CONSTRUCT_COSP_GRIDBOX by roj, Feb 2008
-  !
-  mt_ttl=gbx%mt_ttl  ! these variables really should be moved into the mt structure rather than kept as global arrays.
-  mt_tti=gbx%mt_tti
 
   ! Inputs to Quickbeam
   allocate(hgt_matrix(gbx%Npoints,gbx%Nlevels),p_matrix(gbx%Npoints,gbx%Nlevels), &
            t_matrix(gbx%Npoints,gbx%Nlevels),rh_matrix(gbx%Npoints,gbx%Nlevels))
-  allocate(hm_matrix(gbx%Nhydro,gbx%Npoints,gbx%Nlevels)) 
+  allocate(hm_matrix(gbx%Nhydro,gbx%Npoints,gbx%Nlevels))
   allocate(re_matrix(gbx%Nhydro,gbx%Npoints,gbx%Nlevels))
+  allocate(Np_matrix(gbx%Nhydro,gbx%Npoints,gbx%Nlevels))
 
   ! Outputs from Quickbeam
@@ -131,72 +125,63 @@
   allocate(g_atten_to_vol(gbx%Npoints,gbx%Nlevels))
   allocate(dBZe(gbx%Npoints,gbx%Nlevels))
-  
+
   ! Optional argument. It is computed and returned in the first call to
   ! radar_simulator, and passed as input in the rest
-  allocate(g_to_vol(gbx%Nlevels,gbx%Npoints))
-  
+  allocate(g_to_vol(gbx%Npoints,gbx%Nlevels))
+
+  ! Even if there is no unit conversion, they are needed for type conversion
   p_matrix   = gbx%p/100.0     ! From Pa to hPa
   hgt_matrix = gbx%zlev/1000.0 ! From m to km
-  t_matrix   = gbx%T-273.15    ! From K to C
+  t_matrix   = gbx%T
   rh_matrix  = gbx%q
   re_matrix  = 0.0
-  
-  ! Quickbeam assumes the first row is closest to the radar
-  call order_data(hgt_matrix,hm_matrix,p_matrix,t_matrix, &
-      rh_matrix,gbx%surface_radar,hgt_reversed)
-  
+
+
+  ! set flag denoting position of radar relative to hgt_matrix orientation
+	  ngate = size(hgt_matrix,2)
+
+	  hgt_descending = hgt_matrix(1,1) > hgt_matrix(1,ngate)
+
+	  if ( &
+	     (gbx%surface_radar == 1 .and. hgt_descending) .or.  &
+	     (gbx%surface_radar == 0 .and. (.not. hgt_descending)) &
+	     ) &
+	  then
+	    gbx%hp%radar_at_layer_one = .false.
+	  else
+	    gbx%hp%radar_at_layer_one = .true.
+	  endif
+
   ! ----- loop over subcolumns -----
   do pr=1,sgx%Ncolumns
+
+      !  NOTE:
       !  atmospheric profiles are the same within the same gridbox
-      !  only hydrometeor profiles will be different
-      if (hgt_reversed) then  
-         do i=1,gbx%Nhydro  
-            hm_matrix(i,:,:) = sghydro%mr_hydro(:,pr,gbx%Nlevels:1:-1,i)*1000.0 ! Units from kg/kg to g/kg
-            if (gbx%use_reff) then
-              re_matrix(i,:,:) = sghydro%Reff(:,pr,gbx%Nlevels:1:-1,i)*1.e6     ! Units from m to micron
-            endif
-         enddo  
-      else  
+      !  only hydrometeor profiles will be different for each subgridbox
+
          do i=1,gbx%Nhydro
             hm_matrix(i,:,:) = sghydro%mr_hydro(:,pr,:,i)*1000.0 ! Units from kg/kg to g/kg
             if (gbx%use_reff) then
               re_matrix(i,:,:) = sghydro%Reff(:,pr,:,i)*1.e6       ! Units from m to micron
+              Np_matrix(i,:,:) = sghydro%Np(:,pr,:,i)              ! Units [#/kg]
             endif
          enddo
-      endif  
 
       !   ----- call radar simulator -----
       if (pr == 1) then ! Compute gaseous attenuation for all profiles
-         j=0
-         if (gbx%Npoints == 53) then
-           unt=10
-           j=1
-         endif
-         if (gbx%Npoints == 153) then
-           unt=11
-           j=101
-         endif
-         call radar_simulator(freq,k2,gbx%do_ray,gbx%use_gas_abs,gbx%use_mie_tables,gbx%mt, &    !  v0.2: mt changed to gbx%mt, roj
-           gbx%Nhydro,gbx%hp,gbx%Npoints,gbx%Nlevels,gbx%nsizes,gbx%D, &                         !  v0.2: hp->gbx%hp, D->gbx%d, nsizes->gbx%nsizes, roj
-           hgt_matrix,hm_matrix,re_matrix,p_matrix,t_matrix,rh_matrix, &
+         call radar_simulator(gbx%hp,gbx%Npoints,gbx%Nlevels,R_UNDEF, &
+           hgt_matrix,hm_matrix,re_matrix,Np_matrix, &
+           p_matrix,t_matrix,rh_matrix, &
            Ze_non,Ze_ray,h_atten_to_vol,g_atten_to_vol,dBZe,g_to_vol_out=g_to_vol)
       else ! Use gaseous atteunuation for pr = 1
-         call radar_simulator(freq,k2,gbx%do_ray,gbx%use_gas_abs,gbx%use_mie_tables,gbx%mt, &
-           gbx%Nhydro,gbx%hp,gbx%Npoints,gbx%Nlevels,gbx%nsizes,gbx%D, &
-           hgt_matrix,hm_matrix,re_matrix,p_matrix,t_matrix,rh_matrix, &
+         call radar_simulator(gbx%hp,gbx%Npoints,gbx%Nlevels,R_UNDEF, &
+           hgt_matrix,hm_matrix,re_matrix,Np_matrix, &
+           p_matrix,t_matrix,rh_matrix, &
            Ze_non,Ze_ray,h_atten_to_vol,g_atten_to_vol,dBZe,g_to_vol_in=g_to_vol)
       endif
-      ! ----- BEGIN output section -----
-      ! spaceborne radar : from TOA to SURFACE
-      if (gbx%surface_radar == 1) then
-        z%Ze_tot(:,pr,:)=dBZe(:,:)
-      else if (gbx%surface_radar == 0) then ! Spaceborne
-        z%Ze_tot(:,pr,:)=dBZe(:,gbx%Nlevels:1:-1)
-      endif
 
+      ! store caluculated dBZe values for later output/processing
+      z%Ze_tot(:,pr,:)=dBZe(:,:)
   enddo !pr
-  
-  ! Change undefined value to one defined in COSP
-  where (z%Ze_tot == -999.0) z%Ze_tot = R_UNDEF
 
   deallocate(hgt_matrix,p_matrix,t_matrix,rh_matrix)
@@ -204,8 +189,4 @@
       Ze_non,Ze_ray,h_atten_to_vol,g_atten_to_vol,dBZe)
   deallocate(g_to_vol)
- 
-  ! deallocate(mt_ttl,mt_tti)	!v0.2: roj feb 2008 can not be done here,
-                                !these variables now part of gbx structure and dealocated later
-
 END SUBROUTINE COSP_RADAR
 
Index: LMDZ5/trunk/libf/phylmd/cosp/cosp_simulator.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/cosp_simulator.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/cosp_simulator.F90	(revision 2428)
@@ -1,5 +1,6 @@
 ! (c) British Crown Copyright 2008, the Met Office.
-
 ! All rights reserved.
+! $Revision: 88 $, $Date: 2013-11-13 15:08:38 +0100 (mer. 13 nov. 2013) $
+! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/cosp_simulator.F90 $
 ! 
 ! Redistribution and use in source and binary forms, with or without modification, are permitted 
@@ -27,13 +28,20 @@
 ! History:
 ! Jul 2007 - A. Bodas-Salcedo - Initial version
+! Jan 2013 - G. Cesana - Add new variables linked to the lidar cloud phase 
 !
-!
-
+
+#include "cosp_defs.h" 
 MODULE MOD_COSP_SIMULATOR
+  USE MOD_COSP_CONSTANTS, ONLY: I_RADAR, I_LIDAR, I_ISCCP, I_MISR, I_MODIS, &
+                                I_RTTOV, I_STATS, tsim
   USE MOD_COSP_TYPES
   USE MOD_COSP_RADAR
   USE MOD_COSP_LIDAR
   USE MOD_COSP_ISCCP_SIMULATOR
+  USE MOD_COSP_MODIS_SIMULATOR
   USE MOD_COSP_MISR_SIMULATOR
+!#ifdef RTTOV
+!  USE MOD_COSP_RTTOV_SIMULATOR
+!#endif
   USE MOD_COSP_STATS
   IMPLICIT NONE
@@ -45,11 +53,15 @@
 !--------------------- SUBROUTINE COSP_SIMULATOR ------------------
 !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-SUBROUTINE COSP_SIMULATOR(gbx,sgx,sghydro,cfg,vgrid,sgradar,sglidar,isccp,misr,stradar,stlidar)
+!#ifdef RTTOV
+!SUBROUTINE COSP_SIMULATOR(gbx,sgx,sghydro,cfg,vgrid,sgradar,sglidar,isccp,misr,modis,rttov,stradar,stlidar)
+!#else
+SUBROUTINE COSP_SIMULATOR(gbx,sgx,sghydro,cfg,vgrid,sgradar,sglidar,isccp,misr,modis,stradar,stlidar)
+!#endif
 
   ! Arguments
-  type(cosp_gridbox),intent(in) :: gbx      ! Grid-box inputs
+  type(cosp_gridbox),intent(inout) :: gbx      ! Grid-box inputs
   type(cosp_subgrid),intent(in) :: sgx      ! Subgrid inputs
   type(cosp_sghydro),intent(in) :: sghydro  ! Subgrid info for hydrometeors
-  type(cosp_config),intent(in) :: cfg       ! Configuration options
+  type(cosp_config),intent(in)  :: cfg      ! Configuration options
   type(cosp_vgrid),intent(in)   :: vgrid    ! Information on vertical grid of stats
   type(cosp_sgradar),intent(inout) :: sgradar ! Output from radar simulator
@@ -57,39 +69,171 @@
   type(cosp_isccp),intent(inout)   :: isccp   ! Output from ISCCP simulator
   type(cosp_misr),intent(inout)    :: misr    ! Output from MISR simulator
+  type(cosp_modis),intent(inout)   :: modis   ! Output from MODIS simulator
+!#ifdef RTTOV
+!  type(cosp_rttov),intent(inout)    :: rttov    ! Output from RTTOV
+!#endif
   type(cosp_radarstats),intent(inout) :: stradar ! Summary statistics from radar simulator
   type(cosp_lidarstats),intent(inout) :: stlidar ! Summary statistics from lidar simulator
   ! Local variables
-  ! ***Timing variables (to be deleted in final version)
-  integer :: t0,t1,count_rate,count_max
-
-  !+++++++++ Radar model ++++++++++  
+  integer :: i,j,k,isim
+  logical :: inconsistent
+  ! Timing variables
+  integer :: t0,t1
+
+  t0 = 0
+  t1 = 0
+
+  inconsistent=.false.
+!   do k=1,gbx%Nhydro
+!   do j=1,gbx%Nlevels
+!   do i=1,gbx%Npoints
+!     if ((gbx%mr_hydro(i,j,k)>0.0).and.(gbx%Reff(i,j,k)<=0.0)) inconsistent=.true.
+!   enddo
+!   enddo
+!   enddo
+!  if (inconsistent)  print *, '%%%% COSP_SIMULATOR: inconsistency in mr_hydro and Reff'
+
+
+  !+++++++++ Radar model ++++++++++
+  isim = I_RADAR
   if (cfg%Lradar_sim) then
+    call system_clock(t0)
     call cosp_radar(gbx,sgx,sghydro,sgradar)
-  endif
-  
+    call system_clock(t1)
+    tsim(isim) = tsim(isim) + (t1 -t0)
+  endif
+
   !+++++++++ Lidar model ++++++++++
+  isim = I_LIDAR
   if (cfg%Llidar_sim) then
+    call system_clock(t0)
     call cosp_lidar(gbx,sgx,sghydro,sglidar)
-  endif
-
-  
+    call system_clock(t1)
+    tsim(isim) = tsim(isim) + (t1 -t0)
+  endif
+
   !+++++++++ ISCCP simulator ++++++++++
+  isim = I_ISCCP
   if (cfg%Lisccp_sim) then
+    call system_clock(t0)
     call cosp_isccp_simulator(gbx,sgx,isccp)
-  endif
-  
+    call system_clock(t1)
+    tsim(isim) = tsim(isim) + (t1 -t0)
+  endif
+
   !+++++++++ MISR simulator ++++++++++
+  isim = I_MISR
   if (cfg%Lmisr_sim) then
+    call system_clock(t0)
     call cosp_misr_simulator(gbx,sgx,misr)
-  endif
-  
+    call system_clock(t1)
+    tsim(isim) = tsim(isim) + (t1 -t0)
+  endif
+
+  !+++++++++ MODIS simulator ++++++++++
+  isim = I_MODIS
+  if (cfg%Lmodis_sim) then
+    call system_clock(t0)
+    call cosp_modis_simulator(gbx,sgx,sghydro,isccp, modis)
+    call system_clock(t1)
+    tsim(isim) = tsim(isim) + (t1 -t0)
+  endif
+
+  !+++++++++ RTTOV ++++++++++ 
+  isim = I_RTTOV
+!#ifdef RTTOV
+!  if (cfg%Lrttov_sim) then 
+!    call system_clock(t0)
+!    call cosp_rttov_simulator(gbx,rttov)
+!    call system_clock(t1)
+!    tsim(isim) = tsim(isim) + (t1 -t0)
+!  endif
+!#endif
 
   !+++++++++++ Summary statistics +++++++++++
+  isim = I_STATS
   if (cfg%Lstats) then
+    call system_clock(t0)
     call cosp_stats(gbx,sgx,cfg,sgradar,sglidar,vgrid,stradar,stlidar)
-!    print *, '%%%%%%  Stats:', (t1-t0)*1.0/count_rate, ' s'
-  endif
-
-  
+    call system_clock(t1)
+    tsim(isim) = tsim(isim) + (t1 -t0)
+  endif
+
+  !+++++++++++ Change of units after computation of statistics +++++++++++
+  ! This avoids using UDUNITS in CMOR
+
+  ! Cloud fractions from 1 to %
+  if (cfg%Lclcalipso) then
+    where(stlidar%lidarcld /= R_UNDEF) stlidar%lidarcld = stlidar%lidarcld*100.0
+  endif
+  if (cfg%Lcltcalipso.OR.cfg%Lcllcalipso.OR.cfg%Lclmcalipso.OR.cfg%Lclhcalipso) then
+    where(stlidar%cldlayer /= R_UNDEF) stlidar%cldlayer = stlidar%cldlayer*100.0
+  endif
+  if (cfg%Lclcalipso2) then
+    where(stradar%lidar_only_freq_cloud /= R_UNDEF) stradar%lidar_only_freq_cloud = stradar%lidar_only_freq_cloud*100.0
+  endif
+
+  if (cfg%Lcltcalipsoliq.OR.cfg%Lcllcalipsoliq.OR.cfg%Lclmcalipsoliq.OR.cfg%Lclhcalipsoliq.OR. &
+      cfg%Lcltcalipsoice.OR.cfg%Lcllcalipsoice.OR.cfg%Lclmcalipsoice.OR.cfg%Lclhcalipsoice.OR. &
+      cfg%Lcltcalipsoun.OR.cfg%Lcllcalipsoun.OR.cfg%Lclmcalipsoun.OR.cfg%Lclhcalipsoun ) then
+    where(stlidar%cldlayerphase /= R_UNDEF) stlidar%cldlayerphase = stlidar%cldlayerphase*100.0
+  endif
+  if (cfg%Lclcalipsoliq.OR.cfg%Lclcalipsoice.OR.cfg%Lclcalipsoun) then
+    where(stlidar%lidarcldphase /= R_UNDEF) stlidar%lidarcldphase = stlidar%lidarcldphase*100.0
+  endif
+  if (cfg%Lclcalipsotmp.OR.cfg%Lclcalipsotmpliq.OR.cfg%Lclcalipsotmpice.OR.cfg%Lclcalipsotmpun) then
+    where(stlidar%lidarcldtmp /= R_UNDEF) stlidar%lidarcldtmp = stlidar%lidarcldtmp*100.0
+  endif
+
+  if (cfg%Lcltisccp) then
+     where(isccp%totalcldarea /= R_UNDEF) isccp%totalcldarea = isccp%totalcldarea*100.0
+! Test
+!     where(isccp%totalcldarea == R_UNDEF) isccp%totalcldarea = 0.
+  endif  
+  if (cfg%Lclisccp) then
+    where(isccp%fq_isccp /= R_UNDEF) isccp%fq_isccp = isccp%fq_isccp*100.0
+  endif
+
+  if (cfg%LclMISR) then
+    where(misr%fq_MISR /= R_UNDEF) misr%fq_MISR = misr%fq_MISR*100.0
+  endif
+
+  if (cfg%Lcltlidarradar) then
+    where(stradar%radar_lidar_tcc /= R_UNDEF) stradar%radar_lidar_tcc = stradar%radar_lidar_tcc*100.0
+  endif
+
+  if (cfg%Lclmodis) then
+    where(modis%Optical_Thickness_vs_Cloud_Top_Pressure /= R_UNDEF) modis%Optical_Thickness_vs_Cloud_Top_Pressure = &
+                                                      modis%Optical_Thickness_vs_Cloud_Top_Pressure*100.0
+  endif
+  if (cfg%Lcltmodis) then
+     where(modis%Cloud_Fraction_Total_Mean /= R_UNDEF) modis%Cloud_Fraction_Total_Mean = modis%Cloud_Fraction_Total_Mean*100.0
+  endif
+  if (cfg%Lclwmodis) then
+     where(modis%Cloud_Fraction_Water_Mean /= R_UNDEF) modis%Cloud_Fraction_Water_Mean = modis%Cloud_Fraction_Water_Mean*100.0
+  endif
+  if (cfg%Lclimodis) then
+     where(modis%Cloud_Fraction_Ice_Mean /= R_UNDEF) modis%Cloud_Fraction_Ice_Mean = modis%Cloud_Fraction_Ice_Mean*100.0
+  endif
+
+  if (cfg%Lclhmodis) then
+     where(modis%Cloud_Fraction_High_Mean /= R_UNDEF) modis%Cloud_Fraction_High_Mean = modis%Cloud_Fraction_High_Mean*100.0
+  endif
+  if (cfg%Lclmmodis) then
+     where(modis%Cloud_Fraction_Mid_Mean /= R_UNDEF) modis%Cloud_Fraction_Mid_Mean = modis%Cloud_Fraction_Mid_Mean*100.0
+  endif
+  if (cfg%Lcllmodis) then
+     where(modis%Cloud_Fraction_Low_Mean /= R_UNDEF) modis%Cloud_Fraction_Low_Mean = modis%Cloud_Fraction_Low_Mean*100.0
+  endif
+
+  ! Change pressure from hPa to Pa.
+  if (cfg%Lboxptopisccp) then
+    where(isccp%boxptop /= R_UNDEF) isccp%boxptop = isccp%boxptop*100.0
+  endif
+  if (cfg%Lpctisccp) then
+    where(isccp%meanptop /= R_UNDEF) isccp%meanptop = isccp%meanptop*100.0
+  endif
+
+
 END SUBROUTINE COSP_SIMULATOR
 
Index: LMDZ5/trunk/libf/phylmd/cosp/cosp_stats.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cosp/cosp_stats.F90	(revision 2367)
+++ LMDZ5/trunk/libf/phylmd/cosp/cosp_stats.F90	(revision 2428)
@@ -1,4 +1,6 @@
 ! (c) British Crown Copyright 2008, the Met Office.
 ! All rights reserved.
+! $Revision: 88 $, $Date: 2013-11-13 15:08:38 +0100 (mer. 13 nov. 2013) $
+! $URL: http://cfmip-obs-sim.googlecode.com/svn/stable/v1.4.0/cosp_stats.F90 $
 !
 ! Redistribution and use in source and binary forms, with or without modification, are permitted
@@ -30,6 +32,9 @@
 ! Oct 2008 - H. Chepfer       - Added PARASOL reflectance arguments
 ! Jun 2010 - T. Yokohata, T. Nishimura and K. Ogochi - Added NEC SXs optimisations
-!
-!
+! Jan 2013 - G. Cesana        - Added betaperp and temperature arguments 
+!                             - Added phase 3D/3Dtemperature/Map output variables in diag_lidar 
+!
+!
+#include "cosp_defs.h" 
 MODULE MOD_COSP_STATS
   USE MOD_COSP_CONSTANTS
@@ -66,4 +71,6 @@
    real,dimension(:,:,:),allocatable :: Ze_out,betatot_out,betamol_in,betamol_out,ph_in,ph_out
    real,dimension(:,:),allocatable :: ph_c,betamol_c
+   real,dimension(:,:,:),allocatable ::  betaperptot_out, temp_in, temp_out 
+   real,dimension(:,:),allocatable :: temp_c
 
    Npoints  = gbx%Npoints
@@ -73,5 +80,5 @@
    Nlr      = vgrid%Nlvgrid
 
-   if (cfg%Lcfad_Lidarsr532) ok_lidar_cfad=.true.
+   if (cfg%LcfadLidarsr532) ok_lidar_cfad=.true.
 
    if (vgrid%use_vgrid) then ! Statistics in a different vertical grid
@@ -86,4 +93,11 @@
         ph_out  = 0.0
         ph_c    = 0.0
+        allocate(betaperptot_out(Npoints,Ncolumns,Nlr),temp_in(Npoints,1,Nlevels),temp_out(Npoints,1,Nlr), &
+                 temp_c(Npoints,Nlr))
+        betaperptot_out = 0.0
+        temp_in = 0.0
+        temp_out = 0.0
+        temp_c = 0.0
+
         !++++++++++++ Radar CFAD ++++++++++++++++
         if (cfg%Lradar_sim) then
@@ -100,4 +114,12 @@
             call cosp_change_vertical_grid(Npoints,Ncolumns,Nlevels,gbx%zlev,gbx%zlev_half,sglidar%beta_tot, &
                                            Nlr,vgrid%zl,vgrid%zu,betatot_out)
+
+            temp_in(:,1,:) = gbx%T(:,:)
+            call cosp_change_vertical_grid(Npoints,Ncolumns,Nlevels,gbx%zlev,gbx%zlev_half,sglidar%betaperp_tot, &
+                                           Nlr,vgrid%zl,vgrid%zu,betaperptot_out)
+            call cosp_change_vertical_grid(Npoints,1,Nlevels,gbx%zlev,gbx%zlev_half,temp_in, &
+                                           Nlr,vgrid%zl,vgrid%zu,temp_out)
+            temp_c(:,:) = temp_out(:,1,:)
+
             call cosp_change_vertical_grid(Npoints,1,Nlevels,gbx%zlev,gbx%zlev_half,ph_in, &
                                            Nlr,vgrid%zl,vgrid%zu,ph_out)
@@ -106,13 +128,18 @@
             ! Stats from lidar_stat_summary
             call diag_lidar(Npoints,Ncolumns,Nlr,SR_BINS,PARASOL_NREFL &
-                            ,betatot_out,betamol_c,sglidar%refl,gbx%land,ph_c &
+                            ,temp_c,betatot_out,betaperptot_out,betamol_c,sglidar%refl,gbx%land,ph_c &
                             ,LIDAR_UNDEF,ok_lidar_cfad &
                             ,stlidar%cfad_sr,stlidar%srbval &
-                            ,LIDAR_NCAT,stlidar%lidarcld,stlidar%cldlayer,stlidar%parasolrefl)
+                            ,LIDAR_NCAT,stlidar%lidarcld,stlidar%lidarcldphase &
+                            ,stlidar%cldlayer,stlidar%cldlayerphase,stlidar%lidarcldtmp &
+                            ,stlidar%parasolrefl)
         endif
+
         !++++++++++++ Lidar-only cloud amount and lidar&radar total cloud mount ++++++++++++++++
         if (cfg%Lradar_sim.and.cfg%Llidar_sim) call cosp_lidar_only_cloud(Npoints,Ncolumns,Nlr, &
-                                    betatot_out,betamol_c,Ze_out, &
+                                    temp_c,betatot_out,betaperptot_out,betamol_c,Ze_out, &
                                     stradar%lidar_only_freq_cloud,stradar%radar_lidar_tcc)
+        deallocate(temp_out,temp_c,betaperptot_out)
+
         ! Deallocate arrays at coarse resolution
         deallocate(Ze_out,betatot_out,betamol_in,betamol_out,betamol_c,ph_in,ph_out,ph_c)
@@ -124,11 +151,12 @@
         ! Stats from lidar_stat_summary
         if (cfg%Llidar_sim) call diag_lidar(Npoints,Ncolumns,Nlr,SR_BINS,PARASOL_NREFL &
-                        ,sglidar%beta_tot,sglidar%beta_mol,sglidar%refl,gbx%land,gbx%ph &
+                        ,sglidar%temp_tot,sglidar%beta_tot,sglidar%betaperp_tot,sglidar%beta_mol,sglidar%refl,gbx%land,gbx%ph &
                         ,LIDAR_UNDEF,ok_lidar_cfad &
                         ,stlidar%cfad_sr,stlidar%srbval &
-                        ,LIDAR_NCAT,stlidar%lidarcld,stlidar%cldlayer,stlidar%parasolrefl)
+                        ,LIDAR_NCAT,stlidar%lidarcld,stlidar%lidarcldphase,stlidar%cldlayer,stlidar%cldlayerphase &
+                        ,stlidar%lidarcldtmp,stlidar%parasolrefl)
         !++++++++++++ Lidar-only cloud amount and lidar&radar total cloud mount ++++++++++++++++
         if (cfg%Lradar_sim.and.cfg%Llidar_sim) call cosp_lidar_only_cloud(Npoints,Ncolumns,Nlr, &
-                                    sglidar%beta_tot,sglidar%beta_mol,sgradar%Ze_tot, &
+                                    sglidar%temp_tot,sglidar%beta_tot,sglidar%betaperp_tot,sglidar%beta_mol,sgradar%Ze_tot, &
                                     stradar%lidar_only_freq_cloud,stradar%radar_lidar_tcc)
    endif
@@ -138,12 +166,14 @@
    where (stlidar%cldlayer  == LIDAR_UNDEF) stlidar%cldlayer  = R_UNDEF
    where (stlidar%parasolrefl == LIDAR_UNDEF) stlidar%parasolrefl = R_UNDEF
+   where (stlidar%cldlayerphase  == LIDAR_UNDEF) stlidar%cldlayerphase  = R_UNDEF
+   where (stlidar%lidarcldphase  == LIDAR_UNDEF) stlidar%lidarcldphase  = R_UNDEF
+   where (stlidar%lidarcldtmp  == LIDAR_UNDEF) stlidar%lidarcldtmp  = R_UNDEF
 
 END SUBROUTINE COSP_STATS
 
-
 !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 !---------- SUBROUTINE COSP_CHANGE_VERTICAL_GRID ----------------
 !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-SUBROUTINE COSP_CHANGE_VERTICAL_GRID(Npoints,Ncolumns,Nlevels,zfull,zhalf,y,M,zl,zu,r,log_units)
+SUBROUTINE COSP_CHANGE_VERTICAL_GRID(Npoints,Ncolumns,Nlevels,zfull,zhalf,y,Nglevels,newgrid_bot,newgrid_top,r,log_units)
    implicit none
    ! Input arguments
@@ -154,99 +184,110 @@
    real,dimension(Npoints,Nlevels),intent(in) :: zhalf ! Height at half model levels [m] (Bottom of model layer)
    real,dimension(Npoints,Ncolumns,Nlevels),intent(in) :: y     ! Variable to be changed to a different grid
-   integer,intent(in) :: M  !# levels in the new grid
-   real,dimension(M),intent(in) :: zl ! Lower boundary of new levels  [m]
-   real,dimension(M),intent(in) :: zu ! Upper boundary of new levels  [m]
+   integer,intent(in) :: Nglevels  !# levels in the new grid
+   real,dimension(Nglevels),intent(in) :: newgrid_bot ! Lower boundary of new levels  [m]
+   real,dimension(Nglevels),intent(in) :: newgrid_top ! Upper boundary of new levels  [m]
    logical,optional,intent(in) :: log_units ! log units, need to convert to linear units
    ! Output
-   real,dimension(Npoints,Ncolumns,M),intent(out) :: r ! Variable on new grid
+   real,dimension(Npoints,Ncolumns,Nglevels),intent(out) :: r ! Variable on new grid
 
    ! Local variables
    integer :: i,j,k
    logical :: lunits
-
    integer :: l
-   real,dimension(Npoints) :: ws,sumwyp
-   real,dimension(Npoints,Nlevels) :: xl,xu
-   real,dimension(Npoints,Nlevels) :: w
-   real,dimension(Npoints,Ncolumns,Nlevels) :: yp
+   real :: w ! Weight
+   real :: dbb, dtb, dbt, dtt ! Distances between edges of both grids
+   integer :: Nw  ! Number of weights
+   real :: wt  ! Sum of weights
+   real,dimension(Nlevels) :: oldgrid_bot,oldgrid_top ! Lower and upper boundaries of model grid
+   real :: yp ! Local copy of y at a particular point.
+              ! This allows for change of units.
 
    lunits=.false.
    if (present(log_units)) lunits=log_units
 
-   r(:,:,:) = R_GROUND
-   ! Vertical grid at that point
-   xl(:,:) = zhalf(:,:)
-   xu(:,1:Nlevels-1) = xl(:,2:Nlevels)
-   xu(:,Nlevels) = zfull(:,Nlevels) +  zfull(:,Nlevels) - zhalf(:,Nlevels) ! Top level symmetric
-   yp(:,:,:) = y(:,:,:) ! Temporary variable to regrid
-   ! Check for dBZ and change if necessary
-   if (lunits) then
-     where (y /= R_UNDEF)
-       yp = 10.0**(y/10.0)
-     elsewhere
-       yp = 0.0
-     end where
-   endif
-   do k=1,M
-     ! Find weights
-     w(:,:) = 0.0
-     do j=1,Nlevels
-       do i=1,Npoints
-         if ((xl(i,j) < zl(k)).and.(xu(i,j) > zl(k)).and.(xu(i,j) <= zu(k))) then
-           !xl(j)-----------------xu(j)
-           !      zl(k)------------------------------zu(k)
-           w(i,j) = xu(i,j) - zl(k)
-         else if ((xl(i,j) >= zl(k)).and.(xu(i,j) <= zu(k))) then
-           !           xl(j)-----------------xu(j)
-           !      zl(k)------------------------------zu(k)
-           w(i,j) = xu(i,j) - xl(i,j)
-         else if ((xl(i,j) >= zl(k)).and.(xl(i,j) < zu(k)).and.(xu(i,j) >= zu(k))) then
-           !                           xl(j)-----------------xu(j)
-           !      zl(k)------------------------------zu(k)
-           w(i,j) = zu(k) - xl(i,j)
-         else if ((xl(i,j) <= zl(k)).and.(xu(i,j) >= zu(k))) then
-           !  xl(j)---------------------------xu(j)
-           !        zl(k)--------------zu(k)
-           w(i,j) = zu(k) - zl(k)
+   r = 0.0
+
+   do i=1,Npoints
+     ! Calculate tops and bottoms of new and old grids
+     oldgrid_bot = zhalf(i,:)
+     oldgrid_top(1:Nlevels-1) = oldgrid_bot(2:Nlevels)
+     oldgrid_top(Nlevels) = zfull(i,Nlevels) +  zfull(i,Nlevels) - zhalf(i,Nlevels) ! Top level symmetric
+     l = 0 ! Index of level in the old grid
+     ! Loop over levels in the new grid
+     do k = 1,Nglevels
+       Nw = 0 ! Number of weigths
+       wt = 0.0 ! Sum of weights
+       ! Loop over levels in the old grid and accumulate total for weighted average
+       do
+         l = l + 1
+         w = 0.0 ! Initialise weight to 0
+         ! Distances between edges of both grids
+         dbb = oldgrid_bot(l) - newgrid_bot(k)
+         dtb = oldgrid_top(l) - newgrid_bot(k)
+         dbt = oldgrid_bot(l) - newgrid_top(k)
+         dtt = oldgrid_top(l) - newgrid_top(k)
+         if (dbt >= 0.0) exit ! Do next level in the new grid
+         if (dtb > 0.0) then
+           if (dbb <= 0.0) then
+             if (dtt <= 0) then
+               w = dtb
+             else
+               w = newgrid_top(k) - newgrid_bot(k)
+             endif
+           else
+             if (dtt <= 0) then
+               w = oldgrid_top(l) - oldgrid_bot(l)
+             else
+               w = -dbt
+             endif
+           endif
+           ! If layers overlap (w/=0), then accumulate
+           if (w /= 0.0) then
+             Nw = Nw + 1
+             wt = wt + w
+             do j=1,Ncolumns
+               if (lunits) then
+                 if (y(i,j,l) /= R_UNDEF) then
+                   yp = 10.0**(y(i,j,l)/10.0)
+                 else
+                   yp = 0.0
+                 endif
+               else
+                 yp = y(i,j,l)
+               endif
+               r(i,j,k) = r(i,j,k) + w*yp
+             enddo
+           endif
          endif
        enddo
+       l = l - 2
+       if (l < 1) l = 0
+       ! Calculate average in new grid
+       if (Nw > 0) then
+         do j=1,Ncolumns
+           r(i,j,k) = r(i,j,k)/wt
+         enddo
+       endif
      enddo
-     ! Do the weighted mean
+   enddo
+
+   ! Set points under surface to R_UNDEF, and change to dBZ if necessary
+   do k=1,Nglevels
      do j=1,Ncolumns
-       ws    (:) = 0.0
-       sumwyp(:) = 0.0
-       do l=1,Nlevels
-         do i=1,Npoints
-           if (zu(k) > zhalf(i,1)) then ! Level above model bottom level
-             ws    (i) = ws    (i) + w(i,l)
-             sumwyp(i) = sumwyp(i) + w(i,l)*yp(i,j,l)
+       do i=1,Npoints
+         if (newgrid_top(k) > zhalf(i,1)) then ! Level above model bottom level
+           if (lunits) then
+             if (r(i,j,k) <= 0.0) then
+               r(i,j,k) = R_UNDEF
+             else
+               r(i,j,k) = 10.0*log10(r(i,j,k))
+             endif
            endif
-         enddo
-       enddo
-       do i=1,Npoints
-         if (zu(k) > zhalf(i,1)) then ! Level above model bottom level
-           if (ws(i) > 0.0) r(i,j,k) = sumwyp(i)/ws(i)
+         else ! Level below surface
+           r(i,j,k) = R_GROUND
          endif
        enddo
      enddo
    enddo
-   ! Check for dBZ and change if necessary
-   if (lunits) then
-     do k=1,M
-       do j=1,Ncolumns
-         do i=1,Npoints
-           if (zu(k) > zhalf(i,1)) then ! Level above model bottom level
-             if (r(i,j,k) <= 0.0) then
-                 r(i,j,k) = R_UNDEF
-             else
-                 r(i,j,k) = 10.0*log10(r(i,j,k))
-             endif
-           endif
-         enddo
-       enddo
-     enddo
-   endif
-
-
 
 END SUBROUTINE COSP_CHANGE_VERTICAL_GRID
